//Jeannie Albrecht

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.net.*;
import org.jdom.*;
import org.jdom.output.*;
import org.jdom.input.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;

public class Sword extends HttpServlet {
    Vector groupVec;
    ServletOutputStream out = null;
    static String PATH="/home/albrecht/sword/planetlab/";
    
    public Sword() {
	groupVec=new Vector();
    }

    public void doPost(HttpServletRequest req, HttpServletResponse res) 
        throws ServletException, IOException {
        
        doGet(req, res);
    }   

    public void doGet (HttpServletRequest req, HttpServletResponse res) 
	throws ServletException, IOException {
	
	res.setContentType("text/html");
	out = res.getOutputStream();

	String body=req.getParameter("tarea");
	System.out.println("tarea= "+body);

	if (body.length()>0) {
	    System.out.println("submit button");
	    out.println("<html>");
	    out.println("<head><title>SWORD</title></head>");
	    out.println("<body>");
	    out.println("<h1>Request submitted!!</h1>");
	    //out.println("You requested: <br><pre>"+body+"<br></pre>");
	    
	    Document d=writeXML(body);	   

	    getResponse(d);
	    
	    try {
		//    System.out.println("here");
		String cmd = PATH+"runOpt";
		//System.out.println("here 2");
		Process p=Runtime.getRuntime().exec(cmd);
		BufferedReader stdInput = new BufferedReader(new InputStreamReader(p.getInputStream()));	
		String output = "";	    
		out.println("<pre>");
		while ((output=stdInput.readLine())!=null){
		    //System.out.println(output);
		    out.println(output);
		    System.out.println(output);
		}
		out.println("</pre>");
		out.println("</body></html>");
		out.close(); 
		System.out.println("success!");
	    }
	    
	    catch (Exception e) {
		System.out.println(e);
		out.println("<html>");
		out.println("<head><title>Sword response</title></head>");
		out.println("<body>");
		out.println("An error has occurred.");
		out.println("</body></html>");
		out.close();
	    }
	}
    }
    
    public static void getResponse(Document doc) {
	ObjectOutputStream oos = null;
	try {
	    oos = new ObjectOutputStream(new FileOutputStream(new File (PATH+"reqDoc")));
	    oos.writeObject(doc);
	    oos.close();
	}	
	catch (Exception ee) {
	    System.out.println("ee: "+ee);
	}
    }

    public Document writeXML(String text) {
	SAXBuilder builder=new SAXBuilder();
	Document doc=null;
	Element root=null;
	File f = new File(PATH+"request.xml");
	FileWriter fw = null;
	
	//Need to read in the current XML file	
	if (f.exists()){
	    if(!f.delete()) {
		System.out.println("An error occurred when deleting request.xml");
	    }
	}

	try {
	    fw = new FileWriter(f);
	    fw.write(text);
	    fw.close();
	}
	catch(Exception e) {
	    System.out.println(e);
	}
	
	try {	    
	    doc = builder.build(f);
	} catch(Exception e) {
	    System.out.println("problem here");
	    e.printStackTrace();
	}	
	return doc;
    }       

    public static void main (String args[]) {
	if (args.length != 1) {
	    System.out.println("usage: java Sword request.xml");
	    System.exit(0);
	}
	SAXBuilder builder=new SAXBuilder();
	File f = new File(PATH+args[0]);
	Document d = null;
	try {	    
	    d = builder.build(f);
	} catch(Exception e) {
	    System.out.println("big problem here!");
	    e.printStackTrace();
	}	
	
	getResponse(d);
	    
	try {
	    //    System.out.println("here");
	    String cmd = PATH+"runOpt";
	    //System.out.println("here 2");
	    Process p=Runtime.getRuntime().exec(cmd);
	    BufferedReader stdInput = new BufferedReader(new InputStreamReader(p.getInputStream()));	
	    String output = "";	    
	    while ((output=stdInput.readLine())!=null){
		System.out.println(output);
	    }
	}	    
	catch (Exception e) {
	    System.out.println(e);
	}
    }
}

